$regfile = "m32def.dat"
$crystal = 16000000
$hwstack = 200
$swstack = 200
$framesize = 200
'------------------------------------------------------------------

Config Pinc.7 = Input , Pinc.0 = Output , _
Pinc.1 = Output , Pinc.4 = Output , Pinc.5 = Output , _
Pinc.6 = Input , Pind.7 = Output
Config Adc = Single , Prescaler = 4 , Reference = Internal
Config Spi = Hard , Interrupt = Off , Data Order = Msb , _
Master = Yes , Polarity = Low , Phase = 0 , Clockrate = 4 , Noss = 1
Config Timer1 = Pwm , Pwm = 8 , Prescale = 1 , Compare A Pwm = Clear Down
Config Watchdog = 256


'-------------------------------------------------------------------

Declare Sub Wrt_cmd(byval Cmd As Word)
Declare Sub Send_data(byval_data As Byte)

'-------------------------------------------------------------------

Dim W As Byte , X As Word , Y As Word
Dim Adc_value As Word , Adc_value3 As Byte
Dim Data_counter As Byte , Code(2) As Byte
Dim Audio_enable As Bit
Dim Command(2) As Byte

'-------------------------------------------------
Const _on = 1 : Const _off = 0
'-------------------------------------------------------------------

Nirq Alias Pinc.7
Nsel Alias Portb.4
Tx_en Alias Portc.0 : Rx_en Alias Portc.1
Send_led Alias Portc.4
Receive_led Alias Portc.5
Ptt_key Alias Pinc.6

'---------------------------------------------------------------------

Spiinit
Set Portc.5
Rx_en = 1 : Tx_en = 0

'-------------------------------------------------------------------
Start Adc
Start Watchdog
'---------------------------------------------------------

Wrt_cmd &H80D7
Wrt_cmd &H8039
Wrt_cmd &HA680
Wrt_cmd &HC601
Wrt_cmd &H9403
Wrt_cmd &HC26F
Wrt_cmd &HC484
Wrt_cmd &H98F0
Wrt_cmd &HE000
Wrt_cmd &HC800
Wrt_cmd &HC000
Wrt_cmd &H8201
Do
  If Ptt_key = 0 Then
     Rx_en = 0 : Tx_en = 1
     Wrt_cmd &H8201
     Wrt_cmd &HCA81
     Send_led = _on
     Gosub Send_packet
  ElseIf Nirq = 0 Then
      Tx_en = 0 : Rx_en = 1
      Wrt_cmd &H82D9
      Wrt_cmd &HCA83
      Gosub Receive_data
      Else
  End If
Loop

'-------------------------------------------------------send send packet

Send_packet:
  While Ptt_key = 0

  '--------------------------------open tx

     Wrt_cmd &H0000
     Wrt_cmd &H8239
     Send_data &HAA
     Send_data &HAA
     Send_data &HAA
     Send_data &H2D
     Send_data &HD4

     '----------------------------send start data

     Send_data &H01
     Send_data &HF4

     '-------------------------------send data

     For Y = 1 To 510
      Reset Watchdog
      Adc_value = Getadc(2)
      Shift Adc_value , Right , 2
      Adc_value3 = Adc_value
      Send_data Adc_value3
    Next

  '-------------------------------------close tx

   Send_data &HAA
   Send_data &HAA
   Send_data &HAA
   Wrt_cmd &H8201
  Wend
 Return

 '----------------------------------------receive data from majule

Receive_data:
  Wrt_cmd &HCA83
  For Y = 1 To 512
    Bitwait Nirq , Reset
    Wrt_cmd &H0000
    Wrt_cmd &HB000
    If Y = 1 Then Code(1) = W
    If Y = 2 Then Code(2) = W
    If Code(1) = &H01 And Code(2) = &HF4 Then
       Audio_enable = 1 : Receive_led = _on
    End If
    If Y > 2 And Audio_enable = 1 Then Pwm1a = W
    Reset Watchdog
  Next
  Wrt_cmd &HCA81 : Audio_enable = 0
 Return
 '------------------------------send data to majule

 Sub Send_data(byval_data As Byte)
   Bitwait Nirq , Reset
   Wrt_cmd &HB800 + _data
 End Sub

 '--------------------------------write commandto majule

 Sub Wrt_cmd(byval Cmd As Word)
  Reset Nsel
  Command(1) = High(cmd) : Command(2) = Low(cmd)
  Spiout Command(1) , 1
  W = Spimove(command(2))
  Set Nsel
 End Sub

 '----------------------------------------------------------------
End